#include "Pledge.h"
#include "sys/Syscall.h"
#include "thread/Scheduler.h"
#include "thread/Timer.h"

Result<u64> sys_alarm(Registers*, SyscallArgs args)
{
    unsigned int seconds = (unsigned int)args[0];

    auto* current = Scheduler::current();

    TRY(check_pledge(current, Promise::p_stdio));

    u64 ticks_left = current->timer ? current->timer->ticks_left() : 0;

    if (current->timer) Scheduler::remove_from_timer_queue(current->timer);
    else
        current->timer = TRY(make<Scheduler::Timer>());

    current->timer->total_ticks = seconds * 1000;
    current->timer->thread = current;

    Scheduler::add_to_timer_queue(current->timer);

    return ticks_left * 1000;
}
